proc adjustselection {args} {
	if ![llength $args] {
		global current
		if ![info exists current(object)] return
		set object $current(object)
		private $object keepselection
		catch {unset keepselection}
		catch {destroy .adjustselectiondialog}
		adjustselectiondialog .adjustselectiondialog
		return
	}
	if {[llength $args] != 4} {
		error "Error: wrong # of args: should be \"adjustselection object part types tags\""
	}
	foreach {object part types tags} $args break
	private $object keepselection canvas
	if ![info exists keepselection] {
		set keepselection [$canvas selection get]
	}
	set baseselection $keepselection
	switch $part {
		drawing {
			foreach drawing [list_remdup [list_subindex [$canvas mitemcget $keepselection -tags] 0]] {
				set baseselection [list_union $baseselection [$canvas find withtag $drawing]]
			}
		}
		all {
			set baseselection [$canvas find withtag all]
		}
	}
	if [llength $types] {
		set curselection [list]
		foreach type $types {
			set curselection [list_union $curselection [list_common $baseselection [$canvas find withtag $type]]]
		}
	} else {
		set curselection $baseselection
	}
	if [llength $tags] {
		set endselection [list]
		foreach id $curselection idtags [$canvas mitemcget $curselection -tags] {
			if [llength [list_common $idtags $tags]] {
				lappend endselection $id
			}
		}
	} else {
		set endselection $curselection
	}
	$canvas selection set $endselection
}

proc revertselection {object} {
	private $object keepselection canvas
	if [info exists keepselection] {
		$canvas selection set $keepselection
		unset keepselection
	}
}

proc _adjustselection {dialog {object {}}} {
	if ![string length $object] {
		global current
		if ![info exists current(object)] return
		set object $current(object)
	}
	set part [string tolower [$dialog.options.part get]]
	set type [string tolower [$dialog.options.type get]]
	array set temp {
		all {}
		bases _base
		basepairings _dot
		{non standard basepairings} _dotns
		{helix names} _helixname
		numbering _number
		{auto connections} _autoconnect
		{base connections} _baseconnect
		beads _bead
		box _outbox
	}
	set type $temp($type)
	unset temp
	adjustselection $object $part $type [$dialog.options.tags get]
}
