proc addbeads {object drawing {tags {}} {size fit} {tagsizes {}}} {
	private $object drawinfo canvas
	busy $object "Adding beads"
	$canvas dtag temp temp
	if {"$tagsizes"==""} {
		set haveargs 0
	} else {
		set haveargs 1
		foreach {tag s} $tagsizes {
			if {"$s"=="fit"} {
				set sizea($tag) fit
			} else {
				set sizea($tag) [expr $s/2]
			}
		}
	}
	set tags [list_concat _base $tags]
	set list [eval $canvas find andtags $drawing $tags]
	busy $object "Adding beads" [llength $list]
	foreach base $list {
		set tags [$canvas itemcget $base -tags]
		set Ttags [list_sub $tags -exclude [list_find -regexp $tags _]]
		set tags [concat _bead bead temp $Ttags]
		set s $size
		if $haveargs {
			foreach tag $Ttags {
				if [info exists sizea($tag)] {
					set s $sizea($tag)
					break
				}
			}
		}
		if {"$s"=="fit"} {
			set id [eval $canvas create oval [$canvas bbox $base] {
				-fill gray -outline {} -tags $tags}]
			addlink $object $base $id
		} else {
			if {$s!=0} {
				set x [$canvas coords $base]
				set y [list_pop x]
				set id [$canvas create oval [expr $x-$s] [expr $y-$s] [expr $x+$s] [expr $y+$s] \
					-fill gray -outline {} -tags $tags]
				addlink $object $base $id
			}
		}
		busyincr $object
	}
	$canvas lower temp $drawinfo($drawing,start)
	notbusy $object
}

proc deletebeads {object drawing {tags {}}} {
	private $object canvas
	set tags [list_concat $drawing _bead $tags]
	set items [eval $canvas find andtags $tags]
	set len [llength $items]
	if {$len == 0} return
	busy $object "Deleting beads" $len
	foreach item $items {
		unlink $object $item
		$canvas delete $item
		busyincr $object
	}
	Classy::msg ""
	notbusy $object
}

proc _addbeads {w {tag {}}} {
	global beadvarsize beadfit current
	if $beadfit {
		set size fit
	} else {
		set size [$w.options.size get]
	}
	if $beadvarsize {
		set tagsizes [$w.options.text get 1.0 end]
	} else {
		set tagsizes ""
	}
	addbeads $current(object) $current(drawing) $tag $size $tagsizes
}

proc _deletebeads {w {tag {}}} {
	global current
	deletebeads $current(object) $current(drawing) $tag
}

