proc selectbox {object item} {
	private $object drawinfo canvas
	set tags [$canvas itemcget $item -tags]
	set drawing [lindex $tags 0]
	set name [lindex $tags 1]
	$canvas addtag _sel andtags $drawing $name
}

proc redrawbox {object drawing name} {
	private $object drawinfo canvas
	set coords ""
	foreach {cname cpart cbase} [lrange $name 2 end] {
		set base [expr {$cbase+$drawinfo($drawing,start)}]
		eval lappend coords [$canvas coords $base]
	}
	foreach item [$canvas find andtags $drawing $name] {
		eval $canvas coords $item $coords
	}
	$canvas selection redraw
}

proc boxsize {object item} {
	private $object canvas
	set bbox [$canvas bbox $item]
	return [format "%.1f" [expr (abs([lindex $bbox 0]-[lindex $bbox 2])+abs([lindex $bbox 1]-[lindex $bbox 3]))/(2.0*[$canvas zoom])]]
}

proc addbox {object bases} {
	private $object drawinfo canvas
	set rbases ""
	set drawing ""
	foreach base $bases tags [$canvas mitemcget $bases -tags] {
		if [lsearch -exact $tags _base] {
			lappend rbases $base
			list_addnew drawing [lindex $tags 0]
			eval lappend coords [$canvas coords $base]
		}
	}
	set bases $rbases
	if {[llength $drawing] != 1} {
			error "Bases to connect do not belong to the same drawing"
	}
	set col [$canvas cget -papercolor]
	set size [boxsize $object [lindex $bases 0]]
	set zoom [$canvas zoom]
	set item1 [eval {$canvas	create line} $coords \
		{-tags [list _box _outbox _label] -width [expr $zoom*($size+1.5)] -capstyle round}]
	set item2 [eval {$canvas	create line} $coords \
		{-tags [list _box _inbox _label] -fill $col -width [expr $zoom*$size] -capstyle round}]
	addlink $object $bases [list $item1 $item2] box
	$canvas lower $item1 $drawinfo($drawing,start)
	$canvas lower $item2 $drawinfo($drawing,start)
	return [list $item1 $item2]
}

proc deletebox {object item} {
	private $object drawinfo canvas
	set tags [$canvas itemcget $item -tags]
	set drawing [lindex $tags 0]
	set name [lindex $tags 1]
	valid $object $drawing $name
	set items [$canvas find andtags $drawing $name]
	unlink $object $items
	foreach item $items {
		$canvas delete $item
	}
}

proc box {object {tag {}}} {
	set object [getobj $object]
	private $object canvas
	if ![string length $tag] {
		addbox $object [$canvas selection get]
	} else {
		addbox $object [$canvas find withtag $tag]
	}
}

