bind ConnectMode <<Action>> {connectaction %W %x %y}

bind ConnectMode <Escape> {
	set object [getobj %W]
	private $object connect
	if [info exists connect] {
		bindtags $w $connect(bindtags)
		catch {unset connect}
		nomsg $object
	}
}

proc connectaction {w x y} {
	set object [getobj $w]
	private $object drawinfo current canvas connect
	focus $canvas
	set x [$canvas canvasx $x]
	set y [$canvas canvasy $y]
	set list [$canvas find overlapping [expr {$x-1}] [expr {$y-1}] [expr {$x+1}] [expr {$y+1}]]
	set item [lindex $list end]
	if [llength $item] {
		bindtags $canvas $connect(bindtags)
		addconnectbases $object [list $connect(item) $item]
		catch {unset connect}
		nomsg $object
	} else {
		error "Nothing selected (Press Escape to cancel connect)"
	}
}

proc redrawconnectbases {object drawing idnt} {
	private $object drawinfo canvas
	set base1 [expr {[lindex $idnt 4]+$drawinfo($drawing,start)}]
	set line [lsort [$canvas find andtags $drawing $idnt]]
	foreach base2 [expr {[lindex $idnt 7]+$drawinfo($drawing,start)}] {
		drawconnect $canvas $line $base1 $base2
	}
}

proc baseconnectaddpoint {object ox oy cx cy} {
	set object [getobj $object]
	private $object drawinfo current canvas
	global canvas curitem curchange
	set coords [$canvas coords $current(item)]
	set px [lindex $coords 0]
	set py [lindex $coords 1]
	set i 2
	foreach {x y} [lrange $coords 2 end] {
		if {[expr abs([distancetoline $px $py $x $y $ox $oy])]<2.0} {
			eval $canvas coords $current(item) [linsert $coords $i $cx $cy]
			set current(change) $i
			break
		}
		set px $x
		set py $y
		incr i 2
	}
}

proc addconnectbases {object bases} {
	private $object drawinfo canvas
	set coords ""
	foreach base $bases tags [$canvas mitemcget $bases -tags] {
		if ![lsearch -exact $tags _base] {
			error "One of the objects is not a base"
		}
		list_addnew drawing [lindex $tags 0]
		eval lappend coords [$canvas coords $base]
	}
	if {[llength $drawing] != 1} {
			error "Bases to connect do not belong to the same drawing"
	}
	set lineitem [eval {$canvas create line} $coords \
		{-tags [list _baseconnect _label] -width $drawinfo($drawing,connectsize)}]
	$canvas lower $lineitem $drawinfo($drawing,start)
	lappend items $lineitem
	addlink $object $bases $items bc
	drawconnect $canvas $lineitem [lindex $bases 0] [lindex $bases end]
	return $items
}

proc deleteconnectbases {object item} {
	private $object drawinfo canvas
	set tags [$canvas itemcget $item -tags]
	set drawing [lindex $tags 0]
	set idnt [lindex $tags 1]
	valid $object $drawing $idnt
	set items [$canvas find andtags $drawing $idnt]
	unlink $object $items
	eval $canvas delete $items
}

proc connectbases {object} {
	set object [getobj $object]
	private $object drawinfo canvas current connect
	set itags [$canvas itemcget $current(item) -tags]
	if {[lsearch $itags _base] == -1} {error "This object cannot be connected to another base because it is not a base"}
	set connect(item) $current(item) 
	set connect(bindtags) [bindtags $canvas]
	bindtags $canvas ConnectMode
	msg $object "Click on base to connect to"
}
