proc setconnected {object drawing name part} {
	private $object drawinfo current canvas
	if ![regexp ^H $name] {
		error "Only helix parts can be drawn using connections"
	}
	regsub {'$} $name {} name
	set items ""
	set items3 ""
	foreach item $drawinfo($drawing,$name,ids) item3 $drawinfo($drawing,$name',ids) {
		set obj [lindex [$canvas itemcget $item -tags] 1]
		set type [lindex $obj 1]
		set num [lindex $obj 3]
		if {[string_equal $type d]&&($num == $part)} {
			lappend items $item
			set tags [$canvas itemcget $item -tags]
			$canvas itemconfigure $item -tags [lreplace $tags 1 1 [lreplace [lindex $tags 1] 1 1 c]]
			$canvas itemconfigure $item -tags [lreplace $tags 1 1 [lreplace [lindex $tags 1] 1 1 c]]
		}
		set obj [lindex [$canvas itemcget $item3 -tags] 1]
		set type [lindex $obj 1]
		set num [lindex $obj 3]
		if {[string_equal $type d]&&($num == $part)} {
			lappend items3 $item3
			set tags [$canvas itemcget $item3 -tags]
			$canvas itemconfigure $item3 -tags [lreplace $tags 1 1 [lreplace [lindex $tags 1] 1 1 c]]
		}
	}
	foreach item $drawinfo($drawing,$name,dotids) num $drawinfo($drawing,$name,dots) {
		if {$num == $part} {
			$canvas addtag _hidden withtag $item
			$canvas lower $item _paper
		}		
	}

	set c1 [lindex $items [expr [llength $items]/2]]
	set c2 [lindex [list_reverse $items3] [expr [llength $items3]/2]]
	$canvas addtag _connected withtag [lindex [addconnectbases $object [list $c1 $c2]] 0]
	$canvas addtag _connected withtag [lindex [addbox $object $items] 0]
	$canvas addtag _connected withtag [lindex [addbox $object $items3] 0]
}

proc connected {object} {
	set object [getobj $object]
	private $object drawinfo current canvas
	if ![info exists current(type)] {
		error "No helix part selected"
	}
	if {"$current(type)"=="c"} {
		error "This area is already drawn as a connection"
	}
	if {"$current(type)"!="d"} {
		error "Only helix parts can be drawn using connections"
	}
	setconnected $object $current(drawing) $current(name) $current(part)
}

