proc deletedrawing {object drawing} {
	private $object drawinfo canvas
	undocheck $object
	$canvas delete $drawing
	foreach item [array names drawinfo $drawing,*] {
		$canvas undo add [list unset drawinfo($item)] [list set drawinfo($item) $drawinfo($item)]
		unset drawinfo($item)
	}
	set pre $drawinfo(drawings)
	set drawinfo(drawings) [list_remove $drawinfo(drawings) $drawing]
	$canvas undo add \
		[list set [privatevar $object drawinfo(drawings)] $drawinfo(drawings)] \
		[list set [privatevar $object drawinfo(drawings)] $pre]
	undocheck $object
}

proc clearpage {object} {
	set object [getobj $object]
	wm title $object Rnaviz
	private $object drawinfo canvas current
	catch {unset current(file)}
	zoom $object 100
	$canvas clear
	catch {unset drawinfo}
	set drawinfo(drawings) ""
	$canvas undo check start
}

proc delete {w} {
	set object [getobj $w]
	private $object drawinfo canvas current
	if [info exists current(cpos)] {
		foreach cpos [lsort -integer -decreasing $current(cpos)] {
			set p1 [expr {2 * $cpos}]
			set p2 [expr {$p1 + 1}]
			set current(coords) [lreplace $current(coords) $p1 $p2]
		}
		eval $canvas coords $current(item) $current(coords)
		$canvas selection redraw
		return
	}
	switch [get current(type) ""] {
		box {
			deletebox $object $current(item)
		}
		bc {
			deleteconnectbases $object $current(item)
		}
	}
	set list [list_remdup [list_subindex [$canvas mitemcget _sel -tags] 0]]
	foreach drawing [list_common $list $drawinfo(drawings)] {
		if [Classy::yorn "Are you sure you want to delete the entire drawing $drawing"] {
			deletedrawing $object $drawing
		} else {
			$canvas selection remove $drawing
		}
	}
	$canvas delete _sel
}

