#Functions

proc exitprog {} {
	exit
}

proc filesave {object} {
	set object [getobj $object]
	private $object canvas current
	set w $object.canvas
	if {![info exists current(file)]||("$current(file)" == "")||![string_equal [file extension $current(file)] .str]} {
		saveas $object
	}
	str_save $object $current(file)
	wm title $object "Rnaviz: $current(file)"
	changed $object 0
}

proc saveas {object} {
	set object [getobj $object]
	private $object canvas current
	global status
	if {![info exists current(file)]||("$current(file)" == "")} {
		set init new.str
	} else {
		set init $current(file)
		if ![string_equal [file extension $init] .str] {
			set init [file root $init].str
		}
	}
	set file [Classy::savefile -title "Save as" \
		-defaultextension .str\
		-initialfile $init]
	if {"$file" == ""} return
	str_save $object $file
	set current(file) $file
	wm title $object "Rnaviz: $current(file)"
	changed $object 0
}

proc fileload {args} {
	checkargs fileload "object ?file?" $args
	set object [getobj $object]
	private $object drawinfo canvas current
	if ![string length [Classy::Default get app Classy__FileSelect__curdir]] {
		Classy::Default set app Classy__FileSelect__curdir [file join $::Classy::appdir examples]
	}
	global status
	if [llength $drawinfo(drawings)] {
		if [Classy::yorn "Do you want to delete everything on the page before loading a new structure"] {
			clearpage $object
			catch {unset current(file)}
		}
	}
	if ![info exists file] {
		set files [Classy::selectfile -title Open -selectmode persistent -filtercombopreset [list echo [file join $::Classy::appdir examples *]]]
		if ![llength $files] return
		set file [lindex $files 0]
	} else {
		set files [list $file]
	}
	if ![info exists current(file)] {
		set current(file) [file root $file].str
		wm title $object "Rnaviz: $current(file)"
		set changed 1
	} else {
		set changed 0
	}
	foreach file $files {
		set f [open $file]
		set line [read $f 100]
		set line [lindex [split $line \n] 0]
		close $f
		switch -regexp -- $line {
			{header Classy::Canvas} {
				str_load $object $file
			}
			{^# RnaViz structure} {
				str1_load $object $file
			}
			"^P|D|R*\[ \t\]+\[0-9\]+\[ \t\]+\[0-9\]+\[ \t\]*$" {
				set skeletonfile [selectskeleton]
				loadali $object $file $skeletonfile
			}
			"^\[ \t\]+\[0-9\]+\[ \t\]+\[a-zA-Z\]+ =" {
				set skeletonfile [selectskeleton]
				loadct $object $file $skeletonfile
			}
			"^<\\?xml version=\"1.0\"\\?>" {
				set skeletonfile [selectskeleton]
				rnaml_load $object $file $skeletonfile
			}
			default {
				error "Format of file \"$file\"not recognised"
			}
		}
		if $changed {changed $object 0}
	}
}
