proc flipped {object drawing {name {}}} {
	private $object drawinfo canvas
	set tags [$canvas itemcget $drawinfo($drawing,start) -tags]
	set flipall [inlist $tags _flipall]
	if [string_equal $name ""] {
		return $flipall
	}
	if ![regexp {^H} $name] {
		return 0
	}
	regsub {'$} $name {} name
	if !$flipall {
		set tags [$canvas itemcget [lindex $drawinfo($drawing,$name,ids) 0] -tags]
		if [inlist $tags _flipped] {
			return 1
		} else {
			return 0
		}
	} else {
		set tags [$canvas itemcget [lindex $drawinfo($drawing,$name,ids) 0] -tags]
		if [inlist $tags _flipped] {
			return 0
		} else {
			return 1
		}
	}
}

proc rmflipped {object drawing {{name} {}}} {
	private $object drawinfo canvas
	if [string_equal $name ""] {
		foreach id [$canvas find andtags $drawing _flipped] {
			$canvas dtag $id _flipped
		}
	} else {
		$canvas dtag [lindex $drawinfo($drawing,$name,ids) 0]  _flipped
	}
}

proc unflip {object drawing} {
	private $object drawinfo canvas
	if [flipped $object $drawing]	{
		flipdrawing $object $drawing
	}
	foreach id [$canvas find andtags $drawing _flipped] {
		set list [split [string range [lindex [$canvas itemcget $id -tags] 1] 1 end] ,]
		set name [lindex $list 0]
		fliphelix $object $drawing $name
	}
}

proc flipdrawing {w drawing} {
	set object [getobj $w]
	private $object drawinfo current canvas
	set bbox [$canvas bbox $drawing]
	set x [expr ([lindex $bbox 2]-[lindex $bbox 0])/2]
	set y [expr ([lindex $bbox 3]-[lindex $bbox 1])/2]
	if [flipped $object  $drawing] {
		$canvas dtag $drawinfo($drawing,start) _flipall
	} else {
		$canvas addtag _flipall withtag $drawinfo($drawing,start)
	}
	$canvas scale $drawing $x $y -1 1
	$canvas selection redraw
}

proc fliphelix {object drawing name} {
	if ![regexp {^H} $name] return
	private $object drawinfo canvas
	regsub {'$} $name {} name
	set p5 [lindex $drawinfo($drawing,$name,ids) 0]
	set p3 [lindex $drawinfo($drawing,$name',ids) end]
	set x1 [$canvas coords $p5]
	set y1 [list_pop x1]
	set x2 [$canvas coords $p3]
	set y2 [list_pop x2]
	set angle [expr [sqangle $x1 $y1 $x2 $y2]+90]
	set newangle 0
	set tags [$canvas itemcget $p5 -tags]
	if [inlist $tags _flipped] {
		$canvas dtag $p5 _flipped
	} else {
		$canvas addtag _flipped withtag $p5
	}
	set items [getitem $object $drawing $name]
	$canvas dtag _temp _temp
	$canvas addtag _temp items $items
	$canvas rotate _temp $x1 $y1 [expr $newangle-$angle]
	set cy [expr {([lindex [$canvas coords $p3] 1]+[lindex [$canvas coords $p5] 1])/2}]
	foreach item $items {
		set x [$canvas coords $item]
		set y [list_pop x]
		if {$y>$cy} {
			set ny [expr $cy+($cy-$y)]
		} else {
			set ny [expr $cy-($y-$cy)]
		}
		$canvas coords $item $x $ny
	}
	$canvas rotate _temp $x1 $y1 $angle
	validate $object $drawing
	$canvas selection redraw
}

proc flip {w} {
	set object [getobj $w]
	private $object drawinfo current canvas
	fliphelix $object $current(drawing) $current(name)
}

proc flipall {w {drawing {}}} {
	set object [getobj $w]
	if ![llength $drawing] {
		private $object current
		set drawing $current(drawing)
	}
	flipdrawing $object $drawing
}

