proc addnumber {object drawing pos number args} {
	private $object drawinfo canvas
	global numbering
	foreach temp [array names numbering] {
		set $temp $numbering($temp)
	}
	foreach {var val} $args {
		set $var $val
	}
	set zoom [$canvas zoom]
	set distance [expr $distance*$zoom]
	set item [expr $drawinfo($drawing,start)+$pos]
	set tags [$canvas itemcget $item -tags]
	if ![inlist $tags _base] {
		return
	}
	set prev [expr $item-1]
	set next [expr $item+1]
	if ![inlist [$canvas itemcget $next -tags] _base] {
		set next $drawinfo($drawing,end)
	}
	foreach {x y} [$canvas coords $item] {}
	foreach {px py} [$canvas coords $prev] {}
	foreach {nx ny} [$canvas coords $next] {}
	set a1 [sqangle $x $y $px $py]
	set a2 [sqangle $x $y $nx $ny]
	if {$a1>$a2} {
		set angle [expr {($a1+$a2)/2}]
	} else {
		set angle [expr {($a1+$a2)/2+180}]
	}
	set name [lindex [lindex $tags 1] 2]
	if [flipped $object $drawing $name] {
		set angle [expr $angle-180]
	}
	set nindex [$canvas create text [expr {$x+$distance}] $y -text $number -tags {_number _numbering} -font $font]
	addlink $object $item $nindex num
	$canvas rotate $nindex $x $y $angle
	foreach {nx ny} [$canvas coords $nindex] {}
	set index [$canvas create line $x $y $nx $ny -width [expr $width*$zoom] -tags {_numbering _background }]
	drawconnect $canvas $index $item $nindex 0.9
	addlink $object $item $index numl
	$canvas raise $index $drawinfo($drawing,start)
	return $index
}

proc addbasenumber {w} {
	set object [getobj $w]
	private $object current
	global numbering
	set object [getobj $current(w)]
	private $object drawinfo canvas
	set item $current(item)
	set drawing [get current(drawing) $current(group)]
	if ![inlist $drawinfo(drawings) $drawing] {
		error "Select a drawing first"
	}
	set pos [expr $item-$drawinfo($drawing,start)]
	addnumber $object $drawing $pos [expr {$drawinfo($drawing,startpos)+$pos-1}]
}

proc removebasenumber {w} {
	set object [getobj $w]
	private $object current
	global numbering
	set object [getobj $current(w)]
	private $object drawinfo canvas
	set drawing [get current(drawing) $current(group)]
	if ![inlist $drawinfo(drawings) $drawing] {
		error "Select a drawing first"
	}
	set item $current(item)
	set pos [expr $item-$drawinfo($drawing,start)]
	set tags [$canvas itemcget $item -tags]
	set name [lindex [lindex $tags 1] 2]
	foreach item [get drawinfo($drawing,$name,lids) ""] {
		foreach num [lrange [lindex [$canvas itemcget $item -tags] 1] 4 end] {
			if {$num == $pos} {
				unlink $object $item
				$canvas delete $item
			}
		}
	}
}

proc removenumbering {w} {
	set object [getobj $w]
	private $object current
	global numbering
	set object [getobj $current(w)]
	private $object drawinfo canvas
	set drawing [get current(drawing) $current(group)]
	if ![inlist $drawinfo(drawings) $drawing] {
		error "Select a drawing first"
	}
	set items [$canvas find andtags $drawing _numbering]
	busy $object "Removing numbering" [llength $items]
	foreach item $items {
		unlink $object $item
		$canvas delete $item
		busyincr $object
	}
	notbusy $object
}

proc addnumbering {w} {
	set object [getobj $w]
	private $object current
	global numbering
	set object [getobj $current(w)]
	private $object drawinfo canvas
	set drawing [get current(drawing) $current(group)]
	if ![inlist $drawinfo(drawings) $drawing] {
		error "Select a drawing first"
	}
	if {$numbering(step)<1} {
		set numbering(step) 10
		return
	}
	if [string_equal $drawinfo($drawing,sequence) 1] {
		set list {}
		foreach el $drawinfo(_g1,elementlist) {
			foreach item $drawinfo(_g1,$el,ids) {
				lappend list [$canvas itemcget $item -text]
			}
		}
		set drawinfo($drawing,sequence) $list
	}
	set len [llength $drawinfo($drawing,sequence)]
	set pos $numbering(start)
	set number [expr {$pos+$numbering(first)-1}]
	busy $object "Adding numbering" $len
	for {} {$pos<$len} {} {
		addnumber $object $drawing $pos $number
		incr number $numbering(step)
		incr pos $numbering(step)
		busyincr $object $numbering(step)
	}
	notbusy $object
}

proc redrawnumber {object drawing item} {
	private $object drawinfo canvas
	set tag [lindex [$canvas itemcget $item -tags] 1]
	foreach {temp type name part pos} $tag {break}
	set base [expr {$drawinfo($drawing,start) + $pos}]
	set items ""
	foreach id [get drawinfo($drawing,$name,lids) ""] {
		set tag [lindex [$canvas itemcget $id -tags] 1]
		if ![string_equal [lindex $tag 1] numl] continue
		if {[lindex $tag 4] == $pos} {lappend items $id}
	}
	drawconnect $canvas $items $base $item 0.9
}

proc redonumbering {object drawing name {part {}}} {
	private $object drawinfo canvas
	set plen [string length $part]
	set textitems ""
	set lineitems ""
	foreach item [get drawinfo($drawing,$name,lids) ""] {
		set tag [lindex [$canvas itemcget $item -tags] 1]
		if [string_equal [lindex $tag 1] num] {
			lappend textitems $item
		}
		if [string_equal [lindex $tag 1] numl] {
			lappend lineitems $item
		}
	}
	foreach text $textitems line $lineitems {
		set tag [lindex [$canvas itemcget $text -tags] 1]
		set pos [lindex $tag 4]
		set item [expr $drawinfo($drawing,start)+$pos]
		set distance [eval distance [$canvas coords $item] [$canvas coords $text]]
		set prev [expr $item-1]
		set next [expr $item+1]
		if ![inlist [$canvas itemcget $next -tags] _base] {
			set next $drawinfo($drawing,end)
		}
		foreach {x y} [$canvas coords $item] {}
		foreach {px py} [$canvas coords $prev] {}
		foreach {nx ny} [$canvas coords $next] {}
		set a1 [sqangle $x $y $px $py]
		set a2 [sqangle $x $y $nx $ny]
		if {$a1>$a2} {
			set angle [expr {($a1+$a2)/2}]
		} else {
			set angle [expr {($a1+$a2)/2+180}]
		}
		set name [lindex [lindex [$canvas itemcget $item -tags] 1] 2]
		if [flipped $object $drawing $name] {
			set angle [expr $angle-180]
		}
		$canvas coords $text [expr {$x+$distance}] $y
		$canvas rotate $text $x $y $angle
		drawconnect $canvas $line $item $text 0.9
	}
}

