proc selectelement_action {w ox oy args} {
#putsvars w ox oy args
	set object [getobj $w]
	private $object drawinfo canvas current keepselection
	catch {unset keepselection}
	focus $canvas
	global status
	set status(current) $canvas
	set current(w) $canvas
	set x [$canvas canvasx $ox]
	set y [$canvas canvasy $oy]
	set list [$canvas find overlapping [expr {$x-1}] [expr {$y-1}] [expr {$x+1}] [expr {$y+1}]]
	set item [lindex $list end]
	set tags [$canvas itemcget $item -tags]
	set group [lindex $tags 0]
	set current(drawing) $group
	_settings_init
	if [inlist $drawinfo(drawings) $group] {
		set zoom [$canvas zoom]
		catch {unset current(cpos)}
		set current(w) $canvas
		set current(object) $object
		set current(action) move
		set current(group) $group
		set current(item) $item
		set current(x) $x
		set current(y) $y
		set current(px) [expr {$x/$zoom}]
		set current(py) [expr {$y/$zoom}]
		set name [lindex [lindex $tags 1] 2]
		setangle $object $current(drawing) $name
		getitemdata $object $item current
		if {"$args" != "add"} {
			if {![inlist $tags _sel] || ("$current(type)" == "u")} {
				$canvas selection set {}
				allvalid $object
				addcuritem $object $group $item $current(tool)
			}
			if [inlist {text oval rectangle} [$canvas type $item]] {
				$canvas current $item
			} else {
				$canvas current $item ind
			}
		} else {
			if ![inlist $tags _sel] {
				addcuritem $object $group $item $current(tool)
				if [inlist {text oval rectangle} [$canvas type $item]] {
					$canvas current $item
				} else {
					$canvas current $item ind
				}
			} else {
				if [string_equal $name $current(name)] {
					setangle $object {} {}
				}
				removecuritem $object $group $item $current(tool)
			}
		}
		if [inlist {s l d u} $current(type)] {
			set current(link) [findlinked $object $item]
		} else {
			set current(link) ""
		}
		update_config $object
		undocheck $object
	} else {
		catch {unset current(drawing)}
		if ![inlist $tags _sel] {
			if {"$args" != "add"} {
				allvalid $object
			}
		}
		select_item $object $item $x $y $args
		catch {unset current(type)}
	}
}

proc selectelement_drag {w x y} {
	set object [getobj $w]
	private $object current
	catch {after cancel $current(id)}
	set current(id) [after idle selectelement_updatedrag $object]
}

proc selectelement_updatedrag {w} {
	set object [getobj $w]
	private $object canvas current
	if ![info exists current(type)] {
		select_updatedrag $object
	} else {
		set x [expr [winfo pointerx $canvas]-[winfo rootx $canvas]]
		set y [expr [winfo pointery $canvas]-[winfo rooty $canvas]]
		set x [$canvas canvasx $x]
		set y [$canvas canvasy $y]
		set zoom [$canvas zoom]
		set current(px) [expr {$x/$zoom}]
		set current(py) [expr {$y/$zoom}]
		if ![info exists current(action)] return
		if !$current(rotate) {
			set xm [expr {$x-$current(x)}]
			set ym [expr {$y-$current(y)}]
			switch $current(type) {
				d {
					$canvas move _sel $xm $ym
				}
				l {
					$canvas move $current(item) $xm $ym
					foreach item $current(link) {
						$canvas move $item $xm $ym
					}
				}
				u {
					$canvas move _sel $xm $ym
				}
				s {
					set item $current(item)
					$canvas move $item $xm $ym
					$canvas current $item
					foreach item $current(link) {
						$canvas move $item $xm $ym
					}
				}
				bc {
					if ![info exists current(change)] {
						baseconnectaddpoint $object $x $y $current(x) $current(y)
					} else {
						set temp [$canvas coords $current(item)]
						eval $canvas coords $current(item) [lreplace $temp $current(change) [expr $current(change)+1] $current(x) $current(y)]
					}
				}
				default {
					if ![info exists current(change)] {
						$canvas move _sel $xm $ym
						$canvas selection redraw
					} else {
						set temp [$canvas coords $current(item)]
						$canvas coords $current(item) [lreplace $temp $current(change) [expr $current(change)+1] $current(x) $current(y)]
					}
				}
			}
		} else {
			set rx [$canvas coords _rotatepos]
			set ry [list_pop rx]
			set a [expr [sqangle $rx $ry $x $y]-[sqangle $rx $ry $current(x) $current(y)]]
			$canvas rotate _sel $rx $ry $a
			$canvas selection redraw
		}
		set current(x) $x
		set current(y) $y
	}
}

proc selectelement_release {w x y args} {
	set object [getobj $w]
	private $object canvas drawinfo current
	catch {unset current(change)}
	if ![info exists current(action)] {
		undocheck $object
		return
	}
	if ![info exists current(type)] {
		eval {select_release $object $x $y} $args
		return
	}
	if {"$current(tool)" == "single"} {
		$canvas selection redraw
		undocheck $object
		unset current(action)
	} elseif {"$current(action)" == "move"} {
		set x [$canvas canvasx $x]
		set y [$canvas canvasy $y]
		set zoom [$canvas zoom]
		set current(px) [expr {$x/$zoom}]
		set current(py) [expr {$y/$zoom}]
		set name $current(name)
		set drawing $current(drawing)
		switch $current(type) {
			"l" {
				drawloop $object $drawing $name $current(part) $current(x) $current(y) 1
				$canvas selection redraw
				validate $object $drawing
			}
			"s" {
				drawsingle $object $drawing $name $current(x) $current(y) 1
				$canvas selection redraw
				validate $object $drawing
			}
			"d" {
				validate $object $drawing
			}
			start - end - c {
				validate $object $drawing
			}
			num {
				redrawnumber $object $drawing $current(item)
			}
			u {
				set items $drawinfo($drawing,$name,ids)
				set istart [lindex $items 0]
				set iend [lindex $items end]
				if {$iend == $current(item)} {
					drawunformatted $object $drawing $name
				} else {
					unformattedconnect $object $drawing $name
				}
			}
		}
		undocheck $object
		unset current(action)
	} else {
		select_release $object $x $y $args
	}
}

proc selectelement_abort {w x y} {
	set object [getobj $w]
	private $object current canvas
	catch {unset current(action)}
	$canvas selection redraw
	return -code break
}


