proc selectstem {object drawing name part} {
#putsvars object drawing name part
	private $object drawinfo canvas current
	if ![regexp ^H $name] {error "\"$name\" is not a helix"}
	regsub {'$} $name {} name
	if {[llength $part]!=1} return
	if {("$part"=="1")||("$name"=="start")||("$name"=="end")} {
		selectitem $object $drawing $name
		setattached $object $drawing $name
		set id [lindex $drawinfo($drawing,$name,ids) 0]
		set current(rotatex) [$canvas coords $id]
		set current(rotatey) [list_pop current(rotatex)]
		return
	}	
	set selectlist ""
	invalid $object $drawing $name $part
	invalid $object $drawing $name' $part
	foreach id [list_concat $drawinfo($drawing,$name,ids) $drawinfo($drawing,$name',ids)] \
		obj [list_concat $drawinfo($drawing,$name,objs) $drawinfo($drawing,$name',objs)] {
		set type [lindex $obj 0]
		set num [lindex $obj 1]
		if {$num >= $part} {
			lappend selectlist $id
		}
	}
	foreach id $drawinfo($drawing,$name,dotids) num $drawinfo($drawing,$name,dots) {
		if {$num >= $part} {
			lappend selectlist $id
		}		
	}
	# ss parts
	set items ""
	set elementlist $drawinfo($drawing,elementlist)
	lappend items $drawinfo($drawing,nxt,$name) $drawinfo($drawing,prv,$name')
	set lids [list_concat [get drawinfo($drawing,$name,lids) ""] [get drawinfo($drawing,$name',lids) ""]]
	if [llength $lids] {
		set todo ""
		foreach item $lids {
			set idnt [lindex [$canvas itemcget $item -tags] 1]
			foreach {cname cpart cpos} [lrange $idnt 2 end] break
			regsub {'$} $cname {} cname
			if {[string_equal $cname $name] && ($cpart >= $part)} {
				lappend selectlist $item
				invalid $object $drawing $item
			}
		}
	}
	$canvas selection add $selectlist
	set items [list_remdup $items]
	foreach cname $items {
		invalid $object $drawing $cname
		if [info exists drawinfo($drawing,$cname,ids)] {
			$canvas selection add $drawinfo($drawing,$cname,ids)
			if [info exists drawinfo($drawing,$cname,lids)] {
				$canvas selection add $drawinfo($drawing,$cname,lids)
			}
		}
	}
	if [string_equal $drawinfo($drawing,nxt,$name) $drawinfo($drawing,prv,$name')] {
		valid $object $drawing $drawinfo($drawing,nxt,$name)
	}
}

proc setattached {object drawing args} {
#putsvars object drawing args
	private $object drawinfo canvas
	set elementlist $drawinfo($drawing,elementlist)
	foreach name $args {
		# valid $object $drawing $name
		lappend items $drawinfo($drawing,prv,$name) $drawinfo($drawing,nxt,$name) \
			$drawinfo($drawing,prv,$name') $drawinfo($drawing,nxt,$name')
		if [info exists drawinfo($drawing,$name,lids)] {
			$canvas selection add $drawinfo($drawing,$name,lids)
			invalid $object $drawing $drawinfo($drawing,$name,lids)
		}
	}
	set items [list_remdup $items]
	foreach cname $items {
		invalid $object $drawing $cname
		if [info exists drawinfo($drawing,$cname,ids)] {
			set ids $drawinfo($drawing,$cname,ids)
			$canvas selection add $ids
			if [info exists drawinfo($drawing,$cname,lids)] {
				$canvas selection add $drawinfo($drawing,$cname,lids)
				invalid $object $drawing $drawinfo($drawing,$cname,lids)
			}
		}
	}
	if [string_equal $drawinfo($drawing,nxt,$name) $drawinfo($drawing,prv,$name')] {
		valid $object $drawing $drawinfo($drawing,nxt,$name)
	}
}

proc selectitem {object drawing name} {
	private $object drawinfo canvas
	if [regexp ^H $name] {
		regsub {'$} $name {} name
		$canvas selection add [list_concat $drawinfo($drawing,$name,ids) $drawinfo($drawing,$name',ids) $drawinfo($drawing,$name,dotids) [get drawinfo($drawing,$name,lids) ""]  [get drawinfo($drawing,$name',lids) ""]]
		invalid $object $drawing [list_concat [get drawinfo($drawing,$name,lids) ""]  [get drawinfo($drawing,$name',lids) ""]]
	} else {
		$canvas selection add [list_concat [get drawinfo($drawing,$name,ids) ""] [get drawinfo($drawing,$name,lids) ""]]
		$canvas selection redraw
		invalid $object $drawing [get drawinfo($drawing,$name,lids) ""]
	}	
}

proc deselectitem {object drawing name} {
	private $object drawinfo canvas
	if [regexp ^H $name] {
		regsub {'$} $name {} name
		$canvas selection remove [list_concat $drawinfo($drawing,$name,ids) $drawinfo($drawing,$name',ids) $drawinfo($drawing,$name,dotids) [get drawinfo($drawing,$name,lids) ""]]
	} else {
		$canvas selection remove [list_concat [get drawinfo($drawing,$name,ids) ""] [get drawinfo($drawing,$name,lids) ""]]
		$canvas selection redraw
	}	
}

# itemtypes
# d   segment of double strand
# l   loop
# dot connection between bases
# s   single strand
# u   unformatted single strand
# bc  base connection
# box box around bases
# c   

proc addcuritem {object drawing item mode} {
#putsvars object drawing item mode
	private $object drawinfo canvas current
	if {"$mode" == "single"} {
		$canvas selection add $item
		return
	}
	set name $current(name)
	switch $current(type) {
		dot -
		l -
		d {
			switch $mode {
				element {
					regsub {'$} $name {} name
					selectitem $object $drawing $name
					setattached $object $drawing $name
					set id [lindex $drawinfo($drawing,$name,ids) 0]
					set current(rotatex) [$canvas coords $id]
					set current(rotatey) [list_pop current(rotatex)]
				}
				segment {
					selectstem $object $drawing $name $current(part)
					set id [lindex $drawinfo($drawing,$name,ids) 0]
					set current(rotatex) [$canvas coords $id]
					set current(rotatey) [list_pop current(rotatex)]
				}
				tree {
					regsub {'$} $name {} name
					selectitem $object $drawing $name
					setattached $object $drawing $name
					set id [lindex $drawinfo($drawing,$name,ids) 0]
					set current(rotatex) [$canvas coords $id]
					set current(rotatey) [list_pop current(rotatex)]
					if {("$current(name)"!="start")&&("$current(name)"!="end")} {
						selecttree $object $drawing $name
					}
				}
				subtree {
					selectstem $curname $curpart
					selecttree $canvas
					if {("$curname"!="start")&&("$curname"!="end")} {
						selecttree $canvas
					}
					posrotate
				}
			}
		}
		s {
			selectitem $object $drawing $name
		}
		start {
			$canvas selection add $item
			set elementlist $drawinfo($drawing,elementlist)
			set name [lindex $elementlist 0]
			if [regexp ^S $name] {
				selectitem $object $drawing $name
				invalid $object $drawing $name
			}
		}
		end {
			$canvas selection add $item
			set elementlist $drawinfo($drawing,elementlist)
			set name [lindex $elementlist end]
			if [regexp ^S $name] {
				selectitem $object $drawing $name
				invalid $object $drawing $name
			}
		}
		c {
			set items ""
			set part $current(part)
			set npart [expr {$part+1}]
			set maxparts 0
			foreach item $drawinfo($drawing,$name,ids) obj $drawinfo($drawing,$name,objs) {
				set type [lindex $obj 0]
				set num [lindex $obj 1]
				if {$num == $part} {
					lappend items $item
				} elseif {[string_equal $type l]&&($num == $npart)} {
					lappend items $item
				}
			}
			if {$part != 1} {
				invalid $object $drawing $name $part
			} else {
				if ![regexp {'$} $name] {
					selectitem $object $drawing $drawinfo($drawing,prv,$name)
					invalid $object $drawing $drawinfo($drawing,prv,$name)
				} else {
					selectitem $object $drawing $drawinfo($drawing,nxt,$name)
					invalid $object $drawing $drawinfo($drawing,nxt,$name)
				}
			}
			if {$npart <= $num} {
				invalid $object $drawing $name $npart
			} else {
				if ![regexp {'$} $name] {
					selectitem $object $drawing $drawinfo($drawing,nxt,$name)
					invalid $object $drawing $drawinfo($drawing,nxt,$name)
				} else {
					selectitem $object $drawing $drawinfo($drawing,prv,$name)
					invalid $object $drawing $drawinfo($drawing,prv,$name)
				}
			}
			set lids [get drawinfo($drawing,$name,lids) ""]
			if [llength $lids] {
				foreach item $lids {
					set idnt [lindex [$canvas itemcget $item -tags] 1]
					foreach {cname cpart cpos} [lrange $idnt 2 end] {
						if {[string_equal $cname $name] && ($cpart == $part)} {
							lappend items $item
							invalid $object $drawing $item
						}
					}
				}
			}
			$canvas selection add $items
		}
		u {
			$canvas selection set {}
			set items $drawinfo($drawing,$name,ids)
			set istart [lindex $items 0]
			set iend [lindex $items end]
			if {$current(item) == $iend} {
				$canvas selection add $current(item)
			} else {
				$canvas selection add $items
			}
		}
		box {
			selectbox $object $current(item)
		}
		rc {
			set sel $current(item)
			cselect $canvas
		}
		default {
			set group [$canvas findgroup $item]
			if [inlist $drawinfo(drawings) $group] {
				$canvas selection add $item
			} else {
				$canvas selection add $group
			}
		}
	}
}

proc getitemdata {object item varname} {
	private $object canvas current
	set tags [$canvas itemcget $item -tags]
	set itags [lindex $tags 1]
	foreach {temp current(type) current(name) current(part) current(side)} $itags {break}
	set current(group) [lindex $tags 0]
}

proc removecuritem {object drawing item mode} {
#putsvars object drawing item mode
	private $object drawinfo canvas current
	getitemdata $object $item current
	set name $current(name)
	switch $current(type) {
		dot -
		d {
			switch $mode {
				element {
					regsub {'$} $name {} name
					deselectitem $object $drawing $name
					set elementlist $drawinfo($drawing,elementlist)
					deselectitem $object $drawing $drawinfo($drawing,prv,$name)
					deselectitem $object $drawing $drawinfo($drawing,nxt,$name)
					deselectitem $object $drawing $drawinfo($drawing,prv,$name')
					deselectitem $object $drawing $drawinfo($drawing,nxt,$name')
				}
				segment {
					deselectitem $object $drawing $name
					selectstem $object $drawing $name [expr {$current(part)+1}]
				}
				tree {
					regsub {'$} $name {} name
					deselectitem $object $drawing $name
					set elementlist $drawinfo($drawing,elementlist)
					set pos1 [lsearch $elementlist $name]
					set pos2 [lsearch $elementlist $name']
					incr pos1
					incr pos2 -1
					foreach element [lrange $elementlist $pos1 $pos2] {
						deselectitem $object $drawing $element
						valid $object $drawing $element
					}
					incr pos1 -2
					set item [lindex $elementlist $pos1]
					if [regexp ^S $item] {
						set id [lindex $drawinfo($drawing,$item,ids) 0]
						if [inlist [$canvas itemcget $id -tags] _sel] {
							invalid $object $drawing $item
						}
					}
					incr pos2 2
					set item [lindex $elementlist $pos2]
					if [regexp ^S $item] {
						set id [lindex $drawinfo($drawing,$item,ids) 0]
						if [inlist [$canvas itemcget $id -tags] _sel] {
							invalid $object $drawing $item
						}
					}
				}
			}
		}
		u -
		s {
			deselectitem $object $drawing $name
		}
		l {
			$canvas dtag temp temp
			$canvas addtag temp withtags $curname $curpart
			$canvas dtag temp sel
			cdeselect $canvas temp
		}
		default {
			set group [$canvas findgroup $item]
			if [inlist $drawinfo(drawings) $group] {
				$canvas dtag $item _sel
			} else {
				$canvas dtag $group _sel
			}
			$canvas selection redraw
		}
	}
}

proc selecttree {args} {
	checkargs selecttree "object ?drawing? ?name?" $args
	set object [getobj $object]
	private $object current
	if ![info exists drawing] {
		if ![info exists current(drawing)] {error "No structure drawing selected"}
		set drawing $current(drawing)
	}
	if ![info exists name] {set name $current(name)}
	private $object drawinfo canvas
	if ![regexp ^H $name] {error "\"$name\" is not a helix"}
	regsub {'$} $name {} name
	set elementlist $drawinfo($drawing,elementlist)
	set pos1 [lsearch $elementlist $name]
	set pos2 [lsearch $elementlist $name']
	incr pos1
	incr pos2 -1
	set list ""
	foreach name [lrange $elementlist $pos1 $pos2] {
		if [regexp ^H $name] {
			regsub {'$} $name {} name
			set list [list_concat $list $drawinfo($drawing,$name,ids) $drawinfo($drawing,$name',ids) $drawinfo($drawing,$name,dotids) [get drawinfo($drawing,$name,lids) ""]]
		} else {
			set list [list_concat $list [get drawinfo($drawing,$name,ids) ""] [get drawinfo($drawing,$name,lids) ""]]
		}	
		valid $object $drawing $name
	}
	$canvas selection add $list
	invalid $object $drawing $list
	$canvas selection redraw
}

proc selectall {args} {
	checkargs selectall "object ?drawing?" $args
	set object [getobj $object]
	private $object current canvas
	if ![info exists drawing] {
		if ![info exists current(drawing)] {error "No structure drawing selected"}
		set drawing $current(drawing)
	}
	$canvas selection add $drawing
	allvalid $object
}

proc deselect {object} {
	set object [getobj $object]
	private $object current canvas
	$canvas selection clear
	allvalid $object
}

