set ::_settings {
	xs 10.0 ys 8.0 dist 10.0
	dotwidth 2 dotlen 0
	nsshow 0 nsdotwidth 2
	nsbulge 0 nsdotlen 0
	connectsize 1 connectdist 20
	startpos 1
	basefont {helvetica 8 {}}
 	helixfont {helvetica 12 {bold}}
}

set ::_zoomsettings {xs ys dist dotlen nsbulge nsdotlen connectdist}

proc _settings_set {w} {
	set object [getobj $::current(w)]
	private $object drawinfo current canvas
	set drawing [get current(drawing) ""]
	if ![inlist $drawinfo(drawings) $drawing] {
		error "No structure drawing selected"
	}
	setsettings $object $drawing [array get ::currentsettings]
}

proc _settings_setasdefault {w} {
	global currentsettings
	foreach {key value} $::_settings {
		Classy::Default set app setting_$key $currentsettings($key)
	}
}

proc _settings_defaults {w} {
	global currentsettings
	foreach {key value} $::_settings {
		set currentsettings($key) [Classy::Default get app setting_$key]
	}
}

proc _settings_programdefaults {w} {
	array set ::currentsettings $::_settings
}

proc _settings_init {} {
	set object [getobj $::current(w)]
	private $object drawinfo current canvas
	global currentsettings
	set drawing [get current(drawing) ""]
	if [inlist $drawinfo(drawings) $drawing] {
		foreach {key value} $::_settings {
			set currentsettings($key) $drawinfo($drawing,$key)
		}
	} else {
	}
}

proc setsettings {object drawing {new {}}} {
	private $object canvas drawinfo
	set zoom [$canvas zoom]
	array set temp $::_settings
	foreach {key value} $::_settings {
		set def [Classy::Default get app setting_$key]
		if [string length $def] {
			set temp($key) $def
		}
	}
	array set temp $new
	foreach {key value} $::_settings {
		set drawinfo($drawing,$key) $temp($key)
	}
	foreach key $::_zoomsettings {
		set drawinfo($drawing,zoom_$key) [expr $zoom*$temp($key)]
	}
}

proc getsettings {object drawing} {
	private $object drawinfo zoom
	set result ""
	foreach {key value} $::_settings {
		lappend result $key $drawinfo($drawing,$key)
	}
	foreach {key value} $::_zoomsettings {
		lappend result zoom_$key $drawinfo($drawing,zoom_$key)
	}
	return $result
}

proc scalesettings {object drawing xscale yscale} {
	private $object canvas drawinfo
	set zoom [$canvas zoom]
	foreach {key} {xs ys dist dotwidth dotlen nsdotwidth nsbulge nsdotlen connectsize connectdist} {
		set drawinfo($drawing,$key) [expr {$drawinfo($drawing,$key)*$yscale}]
	}
	foreach {key} {basefont helixfont} {
		set drawinfo($drawing,$key) [Classy::scalefont $drawinfo($drawing,$key) $yscale]
	}
	foreach key $::_zoomsettings {
		set drawinfo($drawing,zoom_$key) [expr $zoom*$drawinfo($drawing,$key)]
	}
	$canvas undo add [list scalesettings $object $drawing $xscale $yscale] [list scalesettings $object $drawing [expr {1/$xscale}] [expr {1/$yscale}]]
	_settings_init
}
