proc str_paste {object data} {
set ::object $object
set ::data $data
	set w $object.canvas
	private $object drawinfo canvas
	set w $object.canvas
	$w dtag _new _new
	busy $object "Loading structure" [llength $data]
	$w configure -progresswindow $object.msg.progress
	$w load $data
	set prevdrawing ""
	set prevname ""
	set skip 0
	set ids [lsort -integer [$canvas find withtag _new]]
	foreach id $ids tags [$canvas mitemcget $ids -tags] {
		set drawing [lindex $tags 0]
		if ![regexp {^_g} $drawing] continue
		set idnt [lindex $tags 1]
		set type [lindex $idnt 1]
		switch $type {
			c -
			l -
			d {
				foreach {name part side} [lrange $idnt 2 4] {break}
				lappend drawinfo($drawing,$name,objs) [list $type $part $side]
				lappend drawinfo($drawing,$name,ids) $id
				if {"$name" != "$prevname"} {
					lappend drawinfo($drawing,elementlist) $name
					set prevname $name
				}
			}
			u -
			s {
				set name [lindex $idnt 2]
				lappend drawinfo($drawing,$name,ids) $id
				if {"$name" != "$prevname"} {
					lappend drawinfo($drawing,elementlist) $name
					set prevname $name
				}
			}
			lnk {
				set name [lindex $idnt 2]
				lappend drawinfo($drawing,$name,lids) $id
			}
			name {
				set name [lindex $idnt 2]
				lappend drawinfo($drawing,$name,lids) $id
				set keepname($name) $id
			}
			x -
			x2 {
				foreach {name part} [lrange $idnt 2 3] {break}
				lappend drawinfo($drawing,$name,lids) $id
				if [string length $part] {
					lappend "drawinfo($drawing,$type $name $part)" $id
				} else {
					lappend "drawinfo($drawing,$type $name)" $id
				}
			}
			box - bc {
				foreach {cname cpart cnum} [lrange $idnt 2 end] {
					list_addnew drawinfo($drawing,$cname,lids) $id
				}
			}
			dotns -
			dot {
				foreach {name part} [lrange $idnt 2 3] {break}
				lappend drawinfo($drawing,$name,dots) $part
				lappend drawinfo($drawing,$name,dotids) $id
			}
			start {
				set name [lindex $idnt 2]
				set data [$canvas itemcget $id -text]
				if {"[lindex $data 0]" != "rnaviz_drawing"} {
					set skip 1
					continue
				}
				set data [lrange $data 1 end]
				set drawinfo($drawing,sequence) [map_get $data sequence]
				setsettings $object $drawing $data
				$canvas itemconfigure $id -text o
				lappend drawinfo(drawings) $drawing
				set drawinfo($drawing,elementlist) ""
				set drawinfo($drawing,start) $id
			}
			end {
				set name [lindex $idnt 2]
				set drawinfo($drawing,end) $id
				set elementlist $drawinfo($drawing,elementlist)
				set prev start
				foreach el $elementlist next [lrange $elementlist 1 end] {
					if {[regexp ^H $el]&&[regexp ^H $prev]} {
						regsub ^H $prev S prev
					}
					set drawinfo($drawing,prv,$el) $prev
					if {[regexp ^H $el]&&[regexp ^H $next]} {
						regsub ^H $el S next
					}
					set drawinfo($drawing,nxt,$el) $next
					set prev $el
				}
				set drawinfo($drawing,nxt,$el) end
			}
			? {
				set nidnt [list _ [lindex $idnt 2]]
				foreach num [lrange $idnt 3 end] {
					set base [expr {$drawinfo($drawing,start)+$num}]
					set btag [lindex [$canvas itemcget $base -tags] 1]
					set bname [lindex $btag 2]
					lappend nidnt $bname [lindex $btag 3] $num
					list_addnew drawinfo($drawing,$bname,lids) $id
				}
				$canvas itemconfigure $id -tags [lreplace $tags 1 1 $nidnt]
			}
		}
		busyincr $object		
	}
	foreach drawing $drawinfo(drawings) {
		set drawinfo($drawing,names) ""
		foreach name $drawinfo($drawing,elementlist) {
			lappend drawinfo($drawing,names) [get keepname($name) ""]
		}
	}
	notbusy $object
	$canvas lower _hidden _paper
}

proc str_load {object file} {
	str_paste $object [file_read $file]
}

proc str_save {object file} {
	set object [getobj $object]
	set w $object.canvas
	private $object drawinfo canvas
	foreach drawing $drawinfo(drawings) {
		set data [list rnaviz_drawing]
		foreach name {
			sequence 
			xs ys dist
			dotwidth dotlen
			nsshow nsdotwidth
			nsbulge nsdotlen
			connectsize connectdist
			startpos
			basefont
		 	helixfont
		} {
			lappend data $name $drawinfo($drawing,$name)
		}
		$canvas itemconfigure $drawinfo($drawing,start) -text $data
	}
	set sel [$canvas selection get]
	$canvas selection set {}
	busy $object "Saving structure" 0
	$w configure -progresswindow $object.msg.progress
	file_write $file [$w save]
	notbusy $object
	foreach drawing $drawinfo(drawings) {
		$canvas itemconfigure $drawinfo($drawing,start) -text o
	}
	$canvas selection add $sel
}


