proc setunformatted {{object {}} {drawing {}} {name {}}} {
#putsvars object drawing name
	global current
	if ![string length $object] {
		set object $current(w)
	}
	set object [getobj $object]
	private $object drawinfo canvas
	if ![string length $drawing] {
		set drawing [get current(drawing) $current(group)]
		if ![inlist $drawinfo(drawings) $drawing] {
			error "Select a structure drawing first"
		}
	}
	if ![string length $name] {
		set name $current(name)
	}
	if ![regexp {^S} $name] {
		error "Only single stranded areas can be unformatted"
	}
	deletebaseconnect $object $drawing [list x $name]
	set items $drawinfo($drawing,$name,ids)
	foreach i $items {
		$canvas itemconfigure $i -tags [lreplace [$canvas itemcget $i -tags] 1 1 [list _ u $name]]
	}
	set start [$canvas coords [lindex $items 0]]
	set end [lindex $items end]
	$canvas coords $end [expr [lindex $start 0]+100] [lindex $start 1]
	drawunformatted $object $drawing $name
}

proc reformatted {{object {}} {drawing {}} {name {}}} {
	global current
	if ![string length $object] {
		set object $current(w)
	}
	set object [getobj $object]
	private $object drawinfo canvas
	if ![string length $drawing] {
		set drawing [get current(drawing) $current(group)]
		if ![inlist $drawinfo(drawings) $drawing] {
			error "Select a structure drawing first"
		}
	}
	if ![string length $name] {
		set name $current(name)
	}
	if ![regexp {^S} $name] {
		error "Only single stranded areas can be reformatted"
	}
	deletebaseconnect $object $drawing [list x $name] $name,lids
	deletebaseconnect $object $drawing [list x2 $name] $name,lids
	foreach i $drawinfo($drawing,$name,ids) {
		$canvas itemconfigure $i -tags [lreplace [$canvas itemcget $i -tags] 1 1 [list _ s $name]]
	}
	arcsingle $object $drawing $name {}
}

proc drawunformatted {object drawing name} {
	private $object drawinfo canvas
	if ![regexp {^S} $name] {
		error "Only single stranded areas can be unformatted"
	}
	set zoom [$canvas zoom]
	set items $drawinfo($drawing,$name,ids)
	set istart [lindex $items 0]
	set iend [lindex $items end]
	foreach {x1 y1} [$canvas coords $istart] {}
	foreach {x2 y2} [$canvas coords $iend] {}
	set start $x1
	set end $x2
	set x $start
	set y $y1
	set xs [expr {$zoom*$drawinfo($drawing,xs)}]
	set font [Classy::zoomfont [$canvas itemcget $istart -font] $zoom]
	set font [lreplace $font 1 1 [expr {round([lindex $font 1])}]]
	set ys [font metrics $font -linespace]
	foreach item $items {
		$canvas coords $item $x $y
		set x [expr $x+$xs]
		if {$x > $end} {
			$canvas addtag _border withtag $item
			set y [expr $y+$ys]
			set x $start
		} else {
			$canvas dtag $item _border
		}
	}
	unformattedconnect $object $drawing $name
}

proc switchvar {a b} {
	upvar $a av
	upvar $b bv
	set temp $av
	set av $bv
	set bv $temp
}

proc between {x a b} {
	if {$a>$b} {switchvar a b}
	if {($x>=$a)&&($x<=$b)} {return 1} else {return 0}
}

foreach var {ax1 ay1 ax2 ay2 bx1 by1 bx2 by2} val {0 0 10 10 1 1 11 11} {
	set $var $val
}
foreach var {ax1 ay1 ax2 ay2 bx1 by1 bx2 by2} val {124.176 212.0 217.971 249.144 149.737 233.235 207.971 305.144} {
	set $var $val
}
proc p {} {
	global ax1 ay1 ax2 ay2 bx1 by1 bx2 by2
	puts "$ax1 $ay1 $ax2 $ay2 $bx1 $by1 $bx2 $by2"
}

proc linescross {ax1 ay1 ax2 ay2 bx1 by1 bx2 by2} {
	if {$ax1>$ax2} {
		switchvar ax1 ax2
		switchvar ay1 ay2
	}
	if {$bx1>$bx2} {
		switchvar bx1 bx2
		switchvar by1 by2
	}
	if {$bx1==$bx2} {
		switchvar ax1 bx1
		switchvar ay1 by1
		switchvar ax2 bx2
		switchvar ay2 by2
	}
	if {($ax1==$ax2)&&($bx1==$bx2)} {
		return 0
	} 
	set ba [expr ($by2-$by1)/($bx2-$bx1)]
	set bb [expr $by1-$ba*$bx1]
	if {$ax1==$ax2} {
		if {($ax1>$bx2)||($ax2<$bx1)} {return 0}
		set y [expr $ba*$ax1+$bb]
		if [between $y $ay1 $ay2] {return 1} else {return 0}
	} else {
		set aa [expr ($ay2-$ay1)/($ax2-$ax1)]
		set ab [expr $ay1-$aa*$ax1]
		if {$ba==$aa} {
			if {$ab==$bb} {return 1} else {return 0}
		}
		set x [expr ($ab-$bb)/($ba-$aa)]
		set y [expr $aa*$x+$ab]
		if {([between $x $ax1 $ax2])&&([between $y $ay1 $ay2])&&([between $x $bx1 $bx2])&&([between $y $by1 $by2])} {
			return 1
		} else {
			return 0
		}
	}
}

proc findzone {x y x1 y1 x2 y2} {
	if {$y<$y1} {
		if {$x<$x1} {
			return A
		} elseif {$x<$x2} {
			return B
		} else {
			return C
		}
	} elseif {$y<$y2} {
		if {$x<$x1} {
			return D
		} elseif {$x<$x2} {
			return CORE
		} else {
			return E
		}
	} else {
		if {$x<$x1} {
			return F
		} elseif {$x<$x2} {
			return G
		} else {
			return H
		}
	}
}

proc unformattedline {name coords items {tag {}}} {
	global canvas drawing drawinfo
	eval {$canvas create line} $coords {-tags "$drawing $name background $tag line" -width $drawinfo($drawing,connectsize)}
	set col [$canvas itemcget paper -fill]
	foreach item $items {
		eval {$canvas create oval} [$canvas bbox $item] {-fill $col -outline $col -width 1 -tags "$drawing $name background papercol $tag"}
	}
	$canvas lower $name
	$canvas raise $name paper
}

proc unformattedconnect {object drawing name} {
	private $object canvas drawinfo
	set items [get drawinfo($drawing,$name,x) ""]
	if [llength $items] {
		eval $canvas delete $items
		set drawinfo($drawing,$name,lids) [list_lremove $drawinfo($drawing,$name,lids) $items]
		unset drawinfo($drawing,$name,x)
	}
	set width $drawinfo($drawing,connectsize)
	set zoom [$canvas zoom]
	set xs [expr {$zoom*$drawinfo($drawing,xs)}]
	if ![info exists drawinfo($drawing,$name,ids)] return
	set items $drawinfo($drawing,$name,ids)
	set istart [lindex $items 0]
	set iend [lindex $items end]
	set prev [expr $istart-1]
	set next [expr $iend+1]
	foreach {x1 y1} [$canvas coords $istart] {}
	foreach {x2 y2} [$canvas coords $iend] {}
	set items ""
	set border ""
	foreach item $drawinfo($drawing,$name,ids) {
		set tags [$canvas itemcget $item -tags]
		if [inlist $tags _border] {
			lappend border $item
		}
		lappend items $item
	}
	if [llength $border] {
		set x2 [lindex [$canvas coords [lindex $border 0]] 0]
	}
	set font [Classy::zoomfont [$canvas itemcget $istart -font] $zoom]
	set font [lreplace $font 1 1 [expr {round([lindex $font 1])}]]
	set ys [font metrics $font -linespace]
	#
	foreach {zx1 zy1} [$canvas coords $prev] {}
	foreach {zx2 zy2} [$canvas coords $next] {}
	set sx1 [expr $x1-$xs]
	set sx2 [expr $x2+$xs]
	set sy1 [expr $y1-$ys]
	set sy2 [expr $y2+$ys]
	#
	set path(A1) [list [list $sx1 $y1 $x1 $y1]]
	set path(B1) [list [list $x1 $sy1 $x1 $y1] [list $sx2 $sy1 $sx2 $sy2 $sx1 $sy2 $sx1 $y1 $x1 $y1]]
	set path(C1) [list [list $x1 $sy1 $x1 $y1] [list $sx2 $sy2 $sx1 $sy2 $sx1 $y1 $x1 $y1]]
	set path(D1) [list [list $sx1 $y1 $x1 $y1]]
	set path(E1) [list [list $sx2 $sy1 $x1 $sy1 $x1 $y1] [list $sx2 $sy2 $sx1 $sy2 $sx1 $y1 $x1 $y1]]
	set path(F1) [list [list $sx1 $y1 $x1 $y1] [list $sx2 $sy2 $sx2 $sy1 $sx1 $sy1 $x1 $y1]]
	set path(G1) [list [list $sx1 $sy2 $sx1 $y1 $x1 $y1] [list $sx2 $sy2 $sx2 $sy1 $x1 $sy1 $x1 $y1]]
	set path(H1) [list [list $sx1 $sy2 $sx1 $y1 $x1 $y1] [list $sx2 $sy1 $x1 $sy1 $x1 $y1]]
	#
	set path(H2) [list [list $sx2 $y2 $x2 $y2]]
	set path(G2) [list [list $sx2 $y2 $x2 $y2] [list $sx1 $sy2 $sx1 $sy1 $sx2 $sy1 $sx2 $y2 $x2 $y2]]
	set path(F2) [list [list $sx2 $y2 $x2 $y2] [list $sx1 $sy1 $sx2 $sy1 $sx2 $y2 $x2 $y2]]
	set path(E2) [list [list $sx2 $y2 $x2 $y2]]
	set path(D2) [list [list $sx1 $sy2 $x2 $sy2 $x2 $y2] [list $sx1 $sy1 $sx2 $sy1 $sx2 $y2 $x2 $y2]]
	set path(C2) [list [list $sx2 $y2 $x2 $y2] [list $sx1 $sy1 $sx1 $sy2 $sx2 $sy2 $x2 $y2]]
	set path(B2) [list [list $sx2 $sy1 $sx2 $y2 $x2 $y2] [list $sx1 $sy1 $sx1 $sy2 $x2 $sy2 $x2 $y2]]
	set path(A2) [list [list $sx2 $sy1 $sx2 $y2 $x2 $y2] [list $sx1 $sy2 $x2 $sy2 $x2 $y2]]
	#	
	set zone1 [findzone $zx1 $zy1 $sx1 $sy1 $sx2 $sy2]
	set zone2 [findzone $zx2 $zy2 $sx1 $sy1 $sx2 $sy2]
	if {("$zone1"=="CORE")||("$zone2"=="CORE")} return
	set found 0
	foreach c1 $path([set zone1]1) {
		foreach c2 $path([set zone2]2) {
			if ![eval linescross $zx1 $zy1 [lrange $c1 0 1] $zx2 $zy2 [lrange $c2 0 1]] {
				set found 1
				break
			}
		}
		if $found break
	}
	if {$found==0} {
		set c1 [lindex $path([set zone1]1) 0]
		set c2 [lindex $path([set zone2]2) 0]
	}
	#
	list_unshift c1 $zy1
	list_unshift c1 $zx1
	list_unshift c2 $zy2
	list_unshift c2 $zx2
	baseconnect $object $drawing [list x $name] $c1 [list $prev $istart] $name,lids
	baseconnect $object $drawing [list x2 $name] $c2 [list $next $iend] $name,lids
	$canvas selection redraw
}
