proc invalid {object drawing name {arg {}}} {
	private $object invalid canvas
	if ![isint [lindex $name 0]] {
		list_addnew invalid($name) $arg
	} else {
		foreach item $name {
			set idnt [lindex [$canvas itemcget $item -tags] 1]
			set invalid($idnt) $arg
		}
	}
}

proc valid {object drawing args} {
	private $object invalid
	foreach name $args {
		catch {unset invalid($name)}
	}
}

proc allvalid {object} {
	private $object invalid
	if [info exists invalid] {unset invalid}
}

proc alllinksvalid {object drawing} {
	private $object invalid
	if ![info exists invalid] return
	foreach name [array names invalid] {
		if [regexp {^[0-9]} $name] {unset invalid($name)}
	}
}

proc validate {object drawing {args {}}} {
	private $object invalid drawinfo canvas
	if ![llength $args] {
		if ![info exists invalid] return
		set names [lsort -decreasing [array names invalid]]
	} else {
		set names [list]
		foreach item $args {
			lappend names [lindex [$canvas itemcget $item -tags] 1]
		}
	}
	update idletasks
	foreach name $names {
		switch -regexp $name {
			^H {
				foreach part $invalid($name) {
					drawloop $object $drawing $name $part {} {} 1
					checkloop $object $drawing $name $part
				}
			}
			^S {
				set item [lindex [get drawinfo($drawing,$name,ids) ""] 0]
				set tags [$canvas itemcget $item -tags]
				if [inlist $tags _noauto] {
					continue
				}
				if ![string_equal [lindex [lindex $tags 1] 1] u] {
					drawsingle $object $drawing $name {} {} 1
					checksingle $object $drawing $name
				} else {
					unformattedconnect $object $drawing $name
				}
			}
			_ {
				set type [lindex $name 1]
				switch $type {
					bc {
						redrawconnectbases $object $drawing $name
					}
					box {
						redrawbox $object $drawing $name
					}
					default {
						catch {unset invalid($name)}
					}
				}
			}
		}
	}
}

proc validatelinks {object drawing name} {
	private $object drawinfo canvas
	regsub {'$} $name  {} name
	foreach item [list_concat [get drawinfo($drawing,$name,lids) ""] [get drawinfo($drawing,$name',lids) ""]] {
		validate $object $drawing $item
	}

}
