Classy::Dialog subclass settingsdialog
settingsdialog method init args {
	super init
	# Create windows
	frame $object.options.frame1  \
		-borderwidth 2 \
		-height 10 \
		-relief groove \
		-width 10
	grid $object.options.frame1 -row 1 -column 1 -sticky nesw
	Classy::NumEntry $object.options.frame1.numentry1 \
		-labelwidth 11 \
		-label {Bulge distance} \
		-textvariable currentsettings(nsbulge) \
		-width 4
	grid $object.options.frame1.numentry1 -row 1 -column 0 -sticky nesw
	Classy::NumEntry $object.options.frame1.numentry2 \
		-labelwidth 11 \
		-label {Line Width} \
		-textvariable currentsettings(nsdotwidth) \
		-width 4
	grid $object.options.frame1.numentry2 -row 3 -column 0 -sticky nesw
	checkbutton $object.options.frame1.checkbutton1 \
		-text {Show non standard base pairs} \
		-variable currentsettings(nsshow)
	grid $object.options.frame1.checkbutton1 -row 0 -column 0 -sticky nesw
	Classy::NumEntry $object.options.frame1.numentry3 \
		-labelwidth 11 \
		-label {Line Length} \
		-textvariable currentsettings(nsdotlen) \
		-width 4
	grid $object.options.frame1.numentry3 -row 2 -column 0 -sticky nesw
	grid columnconfigure $object.options.frame1 0 -weight 1
	frame $object.options.frame2  \
		-borderwidth 2 \
		-height 10 \
		-relief groove \
		-width 10
	grid $object.options.frame2 -row 1 -column 0 -sticky nesw
	Classy::NumEntry $object.options.frame2.numentry1 \
		-labelwidth 11 \
		-label {Base Distance} \
		-textvariable currentsettings(ys) \
		-width 4
	grid $object.options.frame2.numentry1 -row 1 -column 0 -sticky nesw
	Classy::NumEntry $object.options.frame2.numentry2 \
		-labelwidth 11 \
		-label {Line Width} \
		-textvariable currentsettings(dotwidth) \
		-width 4
	grid $object.options.frame2.numentry2 -row 3 -column 0 -sticky nesw
	Classy::NumEntry $object.options.frame2.numentry3 \
		-labelwidth 11 \
		-label {Line Length} \
		-textvariable currentsettings(dotlen) \
		-width 4
	grid $object.options.frame2.numentry3 -row 2 -column 0 -sticky nesw
	label $object.options.frame2.label1 \
		-text {Standard base pairs}
	grid $object.options.frame2.label1 -row 0 -column 0 -sticky nesw
	grid columnconfigure $object.options.frame2 0 -weight 1
	frame $object.options.frame3  \
		-borderwidth 2 \
		-height 10 \
		-relief groove \
		-width 10
	grid $object.options.frame3 -row 0 -column 0 -columnspan 2 -sticky nesw
	Classy::NumEntry $object.options.frame3.numentry1 \
		-label Bases \
		-textvariable currentsettings(dist) \
		-width 4
	grid $object.options.frame3.numentry1 -row 1 -column 0 -sticky nesw
	Classy::NumEntry $object.options.frame3.numentry2 \
		-label {Helix bases} \
		-textvariable currentsettings(xs) \
		-width 4
	grid $object.options.frame3.numentry2 -row 1 -column 1 -sticky nesw
	label $object.options.frame3.label1 \
		-text {Distance between}
	grid $object.options.frame3.label1 -row 0 -column 0 -columnspan 2 -sticky nesw
	grid columnconfigure $object.options.frame3 0 -weight 1
	grid columnconfigure $object.options.frame3 1 -weight 1
	frame $object.options.frame4  \
		-borderwidth 2 \
		-height 10 \
		-relief groove \
		-width 10
	grid $object.options.frame4 -row 2 -column 0 -columnspan 2 -sticky nesw
	Classy::NumEntry $object.options.frame4.numentry1 \
		-label {Line Width} \
		-textvariable currentsettings(connectsize) \
		-width 4
	grid $object.options.frame4.numentry1 -row 1 -column 1 -sticky nesw
	Classy::NumEntry $object.options.frame4.numentry2 \
		-label Treshhold \
		-textvariable currentsettings(connectdist) \
		-width 4
	grid $object.options.frame4.numentry2 -row 1 -column 0 -sticky nesw
	label $object.options.frame4.label1 \
		-text {Auto connect}
	grid $object.options.frame4.label1 -row 0 -column 0 -columnspan 2 -sticky nesw
	grid columnconfigure $object.options.frame4 0 -weight 1
	grid columnconfigure $object.options.frame4 1 -weight 1
	Classy::Selector $object.options.helixfont \
		-label {Helix font} \
		-type font \
		-variable currentsettings(helixfont)
	grid $object.options.helixfont -row 4 -column 0 -columnspan 2 -sticky nesw
	Classy::Selector $object.options.basefont \
		-label {Base font} \
		-type font \
		-variable currentsettings(basefont)
	grid $object.options.basefont -row 3 -column 0 -columnspan 2 -sticky nesw
	grid columnconfigure $object.options 0 -weight 1
	grid columnconfigure $object.options 1 -weight 1
	grid rowconfigure $object.options 4 -weight 1

	if {"$args" == "___Classy::Builder__create"} {return $object}
	# Parse this
	$object configure  \
		-help settings \
		-title {Structure Settings}
	$object add b1 Set [varsubst object {_settings_set $object}] default
	$object add b2 {Set as default} [varsubst object {_settings_setasdefault $object}]
	$object add b3 Defaults [varsubst object {_settings_defaults $object}]
	$object add b4 {Program defaults} [varsubst object {_settings_programdefaults $object}]
	$object persistent set b1 b2 b3 b4
	# Configure initial arguments
	if {"$args" != ""} {eval $object configure $args}
	return $object
}